import { Expand } from "./types";
/**
 * Convert an Expand object (or array of objects) to a clause to use in an OData $expand query parameter
 * @param e Expand(s) to convert
 * @returns OData expand clause string
 */
export declare const ExpandToQuery: (expand?: Expand[] | Expand) => string;
/**
 * Group an array into multiple arrays linked by a common key value
 * @param arr Array to group
 * @param keySelector Function to select property to group by
 * @returns ES6 Map of keys to arrays of values
 */
export declare const GroupArrayBy: <TKey, T>(arr: T[], keySelector: (e: T) => TKey) => Map<TKey, T[]>;
/**
 * Flatten an object to a single level, i.e. { Person: { Name: "John" } } becomes { "Person.Name": "John" }.
 * Arrays are kept as arrays, with their elements flattened.
 * @param obj Object to flatten
 * @param sep Level separator (default ".")
 * @returns Flattened object
 */
export declare const Flatten: (obj: any, sep?: string) => {
    [key: string]: any;
};
export declare const GetPageNumber: () => number;
export declare const GetPageSizeOrDefault: (defaultSize?: number) => number;
